//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PStorageParent_h
#define PStorageParent_h

#include "mozilla/dom/PStorage.h"
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class /*NS_ABSTRACT_CLASS*/ PStorageParent :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::dom::PContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::ItemData ItemData;
    typedef mozilla::dom::StorageItem StorageItem;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::null_t null_t;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PStorage::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvInit(
            const bool& useDB,
            const bool& canUseChromePersist,
            const bool& sessionOnly,
            const nsCString& domain,
            const nsCString& scopeDBKey,
            const nsCString& quotaDomainDBKey,
            const nsCString& quotaETLDplus1DomainDBKey,
            const PRUint32& storageType) = 0;
    virtual bool
    RecvGetKeys(
            const bool& callerSecure,
            InfallibleTArray<nsString>* keys) = 0;
    virtual bool
    RecvGetLength(
            const bool& callerSecure,
            const bool& sessionOnly,
            PRUint32* length,
            nsresult* rv) = 0;
    virtual bool
    RecvGetKey(
            const bool& callerSecure,
            const bool& sessionOnly,
            const PRUint32& index,
            nsString* key,
            nsresult* rv) = 0;
    virtual bool
    RecvGetValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            StorageItem* item,
            nsresult* rv) = 0;
    virtual bool
    RecvSetValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            const nsString& data,
            nsString* oldValue,
            nsresult* rv) = 0;
    virtual bool
    RecvRemoveValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            nsString* oldValue,
            nsresult* rv) = 0;
    virtual bool
    RecvClear(
            const bool& callerSecure,
            const bool& sessionOnly,
            PRInt32* oldCount,
            nsresult* rv) = 0;
    virtual bool
    RecvGetDBValue(
            const nsString& key,
            nsString* value,
            bool* secure,
            nsresult* rv) = 0;
    virtual bool
    RecvSetDBValue(
            const nsString& key,
            const nsString& value,
            const bool& secure,
            nsresult* rv) = 0;
    virtual bool
    RecvSetSecure(
            const nsString& key,
            const bool& secure,
            nsresult* rv) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PStorageParent();

    virtual ~PStorageParent();

    PContentParent*
    Manager();

    PStorage::State
    state();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const ItemData& __v,
            Message* __msg);

    bool
    Read(
            ItemData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PStorageParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PStorageParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StorageItem& __v,
            Message* __msg);

    bool
    Read(
            StorageItem* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class StorageParent :
    public PStorageParent
{
    virtual bool
    RecvInit(
            const bool& useDB,
            const bool& canUseChromePersist,
            const bool& sessionOnly,
            const nsCString& domain,
            const nsCString& scopeDBKey,
            const nsCString& quotaDomainDBKey,
            const nsCString& quotaETLDplus1DomainDBKey,
            const PRUint32& storageType);

    virtual bool
    RecvGetKeys(
            const bool& callerSecure,
            InfallibleTArray<nsString>* keys);

    virtual bool
    RecvGetLength(
            const bool& callerSecure,
            const bool& sessionOnly,
            PRUint32* length,
            nsresult* rv);

    virtual bool
    RecvGetKey(
            const bool& callerSecure,
            const bool& sessionOnly,
            const PRUint32& index,
            nsString* key,
            nsresult* rv);

    virtual bool
    RecvGetValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            StorageItem* item,
            nsresult* rv);

    virtual bool
    RecvSetValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            const nsString& data,
            nsString* oldValue,
            nsresult* rv);

    virtual bool
    RecvRemoveValue(
            const bool& callerSecure,
            const bool& sessionOnly,
            const nsString& key,
            nsString* oldValue,
            nsresult* rv);

    virtual bool
    RecvClear(
            const bool& callerSecure,
            const bool& sessionOnly,
            PRInt32* oldCount,
            nsresult* rv);

    virtual bool
    RecvGetDBValue(
            const nsString& key,
            nsString* value,
            bool* secure,
            nsresult* rv);

    virtual bool
    RecvSetDBValue(
            const nsString& key,
            const nsString& value,
            const bool& secure,
            nsresult* rv);

    virtual bool
    RecvSetSecure(
            const nsString& key,
            const bool& secure,
            nsresult* rv);

    StorageParent();
    virtual ~StorageParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
StorageParent::RecvInit(
        const bool& useDB,
        const bool& canUseChromePersist,
        const bool& sessionOnly,
        const nsCString& domain,
        const nsCString& scopeDBKey,
        const nsCString& quotaDomainDBKey,
        const nsCString& quotaETLDplus1DomainDBKey,
        const PRUint32& storageType)
{
    return false;
}

bool
StorageParent::RecvGetKeys(
        const bool& callerSecure,
        InfallibleTArray<nsString>* keys)
{
    return false;
}

bool
StorageParent::RecvGetLength(
        const bool& callerSecure,
        const bool& sessionOnly,
        PRUint32* length,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvGetKey(
        const bool& callerSecure,
        const bool& sessionOnly,
        const PRUint32& index,
        nsString* key,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvGetValue(
        const bool& callerSecure,
        const bool& sessionOnly,
        const nsString& key,
        StorageItem* item,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvSetValue(
        const bool& callerSecure,
        const bool& sessionOnly,
        const nsString& key,
        const nsString& data,
        nsString* oldValue,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvRemoveValue(
        const bool& callerSecure,
        const bool& sessionOnly,
        const nsString& key,
        nsString* oldValue,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvClear(
        const bool& callerSecure,
        const bool& sessionOnly,
        PRInt32* oldCount,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvGetDBValue(
        const nsString& key,
        nsString* value,
        bool* secure,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvSetDBValue(
        const nsString& key,
        const nsString& value,
        const bool& secure,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvSetSecure(
        const nsString& key,
        const bool& secure,
        nsresult* rv)
{
    return false;
}

StorageParent::StorageParent()
{
    MOZ_COUNT_CTOR(StorageParent);
}

StorageParent::~StorageParent()
{
    MOZ_COUNT_DTOR(StorageParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PStorageParent_h
