//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PJetpack_h
#define PJetpack_h

#include "base/basictypes.h"
#include "prtime.h"
#include "nscore.h"
#include "IPCMessageStart.h"
#include "IPC/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "nsIFile.h"
#include "mozilla/ipc/ProtocolUtils.h"

namespace mozilla {
namespace jetpack {
class Variant;
} // namespace jetpack
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct KeyValue|
//
namespace mozilla {
namespace jetpack {
class NS_FINAL_CLASS KeyValue
{
private:
    typedef mozilla::jetpack::Variant Variant;

public:
    KeyValue();

    KeyValue(
            const nsString& _key,
            const Variant& _value)
    {
        Init();
        Assign(_key, _value);
    }

    KeyValue(const KeyValue& _o)
    {
        Init();
        Assign((_o).key(), (_o).value());
    }

    ~KeyValue();

    void
    operator=(const KeyValue& _o)
    {
        Assign((_o).key(), (_o).value());
    }

    bool
    operator==(const KeyValue& _o) const;

    nsString&
    key()
    {
        return key_;
    }
    const nsString&
    key() const
    {
        return key_;
    }

    Variant&
    value()
    {
        return (*(value_));
    }
    const Variant&
    value() const
    {
        return (*(value_));
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _key,
            const Variant& _value);

    nsString key_;
    Variant* value_;
};
} // namespace jetpack
} // namespace mozilla

namespace mozilla {
namespace jetpack {
class PHandleParent;
} // namespace jetpack
} // namespace mozilla

namespace mozilla {
namespace jetpack {
class PHandleChild;
} // namespace jetpack
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union PrimVariant|
//
namespace mozilla {
namespace jetpack {
class NS_FINAL_CLASS PrimVariant
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        Tnull_t,
        Tbool,
        Tint,
        Tdouble,
        TnsString,
        TPHandleParent,
        TPHandleChild,
        T__Last = TPHandleChild
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::null_t null_t;
    typedef mozilla::jetpack::PHandleParent PHandleParent;
    typedef mozilla::jetpack::PHandleChild PHandleChild;
    typedef void_t void_t__tdef;
    typedef null_t null_t__tdef;
    typedef bool bool__tdef;
    typedef int int__tdef;
    typedef double double__tdef;
    typedef nsString nsString__tdef;
    typedef PHandleParent* PHandleParent__tdef;
    typedef PHandleChild* PHandleChild__tdef;

    union Value {
        char Vvoid_t[sizeof(void_t)];
        char Vnull_t[sizeof(null_t)];
        char Vbool[sizeof(bool)];
        char Vint[sizeof(int)];
        char Vdouble[sizeof(double)];
        char VnsString[sizeof(nsString)];
        char VPHandleParent[sizeof(PHandleParent*)];
        char VPHandleChild[sizeof(PHandleChild*)];
    };

    void_t*
    ptr_void_t()
    {
        return reinterpret_cast<void_t*>((&((mValue).Vvoid_t)));
    }
    const void_t* const
    constptr_void_t() const
    {
        return reinterpret_cast<const void_t* const>((&((mValue).Vvoid_t)));
    }
    null_t*
    ptr_null_t()
    {
        return reinterpret_cast<null_t*>((&((mValue).Vnull_t)));
    }
    const null_t* const
    constptr_null_t() const
    {
        return reinterpret_cast<const null_t* const>((&((mValue).Vnull_t)));
    }
    bool*
    ptr_bool()
    {
        return reinterpret_cast<bool*>((&((mValue).Vbool)));
    }
    const bool* const
    constptr_bool() const
    {
        return reinterpret_cast<const bool* const>((&((mValue).Vbool)));
    }
    int*
    ptr_int()
    {
        return reinterpret_cast<int*>((&((mValue).Vint)));
    }
    const int* const
    constptr_int() const
    {
        return reinterpret_cast<const int* const>((&((mValue).Vint)));
    }
    double*
    ptr_double()
    {
        return reinterpret_cast<double*>((&((mValue).Vdouble)));
    }
    const double* const
    constptr_double() const
    {
        return reinterpret_cast<const double* const>((&((mValue).Vdouble)));
    }
    nsString*
    ptr_nsString()
    {
        return reinterpret_cast<nsString*>((&((mValue).VnsString)));
    }
    const nsString* const
    constptr_nsString() const
    {
        return reinterpret_cast<const nsString* const>((&((mValue).VnsString)));
    }
    PHandleParent**
    ptr_PHandleParent()
    {
        return reinterpret_cast<PHandleParent**>((&((mValue).VPHandleParent)));
    }
    PHandleParent* const*
    constptr_PHandleParent() const
    {
        return reinterpret_cast<PHandleParent* const*>((&((mValue).VPHandleParent)));
    }
    PHandleChild**
    ptr_PHandleChild()
    {
        return reinterpret_cast<PHandleChild**>((&((mValue).VPHandleChild)));
    }
    PHandleChild* const*
    constptr_PHandleChild() const
    {
        return reinterpret_cast<PHandleChild* const*>((&((mValue).VPHandleChild)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    PrimVariant() :
        mType(T__None)
    {
    }

    PrimVariant(const void_t& aOther);

    PrimVariant(const null_t& aOther);

    PrimVariant(const bool& aOther);

    PrimVariant(const int& aOther);

    PrimVariant(const double& aOther);

    PrimVariant(const nsString& aOther);

    PrimVariant(PHandleParent* aOther);

    PrimVariant(PHandleChild* aOther);

    PrimVariant(const PrimVariant& aOther);

    ~PrimVariant();

    Type
    type() const
    {
        return mType;
    }

    PrimVariant&
    operator=(const void_t& aRhs);

    PrimVariant&
    operator=(const null_t& aRhs);

    PrimVariant&
    operator=(const bool& aRhs);

    PrimVariant&
    operator=(const int& aRhs);

    PrimVariant&
    operator=(const double& aRhs);

    PrimVariant&
    operator=(const nsString& aRhs);

    PrimVariant&
    operator=(PHandleParent* aRhs);

    PrimVariant&
    operator=(PHandleChild* aRhs);

    PrimVariant&
    operator=(const PrimVariant& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const bool& aRhs) const;

    bool
    operator==(const int& aRhs) const;

    bool
    operator==(const double& aRhs) const;

    bool
    operator==(const nsString& aRhs) const;

    bool
    operator==(PHandleParent* aRhs) const;

    bool
    operator==(PHandleChild* aRhs) const;

    bool
    operator==(const PrimVariant& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    bool&
    get_bool()
    {
        AssertSanity(Tbool);
        return (*(ptr_bool()));
    }
    const bool&
    get_bool() const
    {
        AssertSanity(Tbool);
        return (*(constptr_bool()));
    }
    operator bool&()
    {
        return get_bool();
    }
    operator const bool&() const
    {
        return get_bool();
    }

    int&
    get_int()
    {
        AssertSanity(Tint);
        return (*(ptr_int()));
    }
    const int&
    get_int() const
    {
        AssertSanity(Tint);
        return (*(constptr_int()));
    }
    operator int&()
    {
        return get_int();
    }
    operator const int&() const
    {
        return get_int();
    }

    double&
    get_double()
    {
        AssertSanity(Tdouble);
        return (*(ptr_double()));
    }
    const double&
    get_double() const
    {
        AssertSanity(Tdouble);
        return (*(constptr_double()));
    }
    operator double&()
    {
        return get_double();
    }
    operator const double&() const
    {
        return get_double();
    }

    nsString&
    get_nsString()
    {
        AssertSanity(TnsString);
        return (*(ptr_nsString()));
    }
    const nsString&
    get_nsString() const
    {
        AssertSanity(TnsString);
        return (*(constptr_nsString()));
    }
    operator nsString&()
    {
        return get_nsString();
    }
    operator const nsString&() const
    {
        return get_nsString();
    }

    PHandleParent*&
    get_PHandleParent()
    {
        AssertSanity(TPHandleParent);
        return (*(ptr_PHandleParent()));
    }
    PHandleParent*
    get_PHandleParent() const
    {
        AssertSanity(TPHandleParent);
        return (*(constptr_PHandleParent()));
    }
    operator PHandleParent*&()
    {
        return get_PHandleParent();
    }
    operator PHandleParent*() const
    {
        return get_PHandleParent();
    }

    PHandleChild*&
    get_PHandleChild()
    {
        AssertSanity(TPHandleChild);
        return (*(ptr_PHandleChild()));
    }
    PHandleChild*
    get_PHandleChild() const
    {
        AssertSanity(TPHandleChild);
        return (*(constptr_PHandleChild()));
    }
    operator PHandleChild*&()
    {
        return get_PHandleChild();
    }
    operator PHandleChild*() const
    {
        return get_PHandleChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace jetpack
} // namespace mozilla

namespace mozilla {
namespace jetpack {
class KeyValue;
} // namespace jetpack
} // namespace mozilla
namespace mozilla {
namespace jetpack {
class Variant;
} // namespace jetpack
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union CompVariant|
//
namespace mozilla {
namespace jetpack {
class NS_FINAL_CLASS CompVariant
{
public:
    enum Type {
        T__None,
        TArrayOfKeyValue = 1,
        TArrayOfVariant,
        Tsize_t,
        T__Last = Tsize_t
    };

private:
    typedef mozilla::jetpack::KeyValue KeyValue;
    typedef mozilla::jetpack::Variant Variant;
    typedef InfallibleTArray<KeyValue>* ArrayOfKeyValue__tdef;
    typedef InfallibleTArray<Variant>* ArrayOfVariant__tdef;
    typedef size_t size_t__tdef;

    union Value {
        InfallibleTArray<KeyValue>* VArrayOfKeyValue;
        InfallibleTArray<Variant>* VArrayOfVariant;
        char Vsize_t[sizeof(size_t)];
    };

    InfallibleTArray<KeyValue>*&
    ptr_ArrayOfKeyValue()
    {
        return (mValue).VArrayOfKeyValue;
    }
    const InfallibleTArray<KeyValue>* const
    constptr_ArrayOfKeyValue() const
    {
        return (mValue).VArrayOfKeyValue;
    }
    InfallibleTArray<Variant>*&
    ptr_ArrayOfVariant()
    {
        return (mValue).VArrayOfVariant;
    }
    const InfallibleTArray<Variant>* const
    constptr_ArrayOfVariant() const
    {
        return (mValue).VArrayOfVariant;
    }
    size_t*
    ptr_size_t()
    {
        return reinterpret_cast<size_t*>((&((mValue).Vsize_t)));
    }
    const size_t* const
    constptr_size_t() const
    {
        return reinterpret_cast<const size_t* const>((&((mValue).Vsize_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    CompVariant() :
        mType(T__None)
    {
    }

    CompVariant(const InfallibleTArray<KeyValue>& aOther);

    CompVariant(const InfallibleTArray<Variant>& aOther);

    CompVariant(const size_t& aOther);

    CompVariant(const CompVariant& aOther);

    ~CompVariant();

    Type
    type() const
    {
        return mType;
    }

    CompVariant&
    operator=(const InfallibleTArray<KeyValue>& aRhs);

    CompVariant&
    operator=(const InfallibleTArray<Variant>& aRhs);

    CompVariant&
    operator=(const size_t& aRhs);

    CompVariant&
    operator=(const CompVariant& aRhs);

    bool
    operator==(const InfallibleTArray<KeyValue>& aRhs) const;

    bool
    operator==(const InfallibleTArray<Variant>& aRhs) const;

    bool
    operator==(const size_t& aRhs) const;

    bool
    operator==(const CompVariant& aRhs) const;

    InfallibleTArray<KeyValue>&
    get_ArrayOfKeyValue()
    {
        AssertSanity(TArrayOfKeyValue);
        return (*(ptr_ArrayOfKeyValue()));
    }
    const InfallibleTArray<KeyValue>&
    get_ArrayOfKeyValue() const
    {
        AssertSanity(TArrayOfKeyValue);
        return (*(constptr_ArrayOfKeyValue()));
    }
    operator InfallibleTArray<KeyValue>&()
    {
        return get_ArrayOfKeyValue();
    }
    operator const InfallibleTArray<KeyValue>&() const
    {
        return get_ArrayOfKeyValue();
    }

    InfallibleTArray<Variant>&
    get_ArrayOfVariant()
    {
        AssertSanity(TArrayOfVariant);
        return (*(ptr_ArrayOfVariant()));
    }
    const InfallibleTArray<Variant>&
    get_ArrayOfVariant() const
    {
        AssertSanity(TArrayOfVariant);
        return (*(constptr_ArrayOfVariant()));
    }
    operator InfallibleTArray<Variant>&()
    {
        return get_ArrayOfVariant();
    }
    operator const InfallibleTArray<Variant>&() const
    {
        return get_ArrayOfVariant();
    }

    size_t&
    get_size_t()
    {
        AssertSanity(Tsize_t);
        return (*(ptr_size_t()));
    }
    const size_t&
    get_size_t() const
    {
        AssertSanity(Tsize_t);
        return (*(constptr_size_t()));
    }
    operator size_t&()
    {
        return get_size_t();
    }
    operator const size_t&() const
    {
        return get_size_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace jetpack
} // namespace mozilla

namespace mozilla {
namespace jetpack {
class PrimVariant;
} // namespace jetpack
} // namespace mozilla
namespace mozilla {
namespace jetpack {
class CompVariant;
} // namespace jetpack
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union Variant|
//
namespace mozilla {
namespace jetpack {
class NS_FINAL_CLASS Variant
{
public:
    enum Type {
        T__None,
        TPrimVariant = 1,
        TCompVariant,
        T__Last = TCompVariant
    };

private:
    typedef mozilla::jetpack::PrimVariant PrimVariant;
    typedef mozilla::jetpack::CompVariant CompVariant;
    typedef PrimVariant PrimVariant__tdef;
    typedef CompVariant* CompVariant__tdef;

    union Value {
        char VPrimVariant[sizeof(PrimVariant)];
        CompVariant* VCompVariant;
    };

    PrimVariant*
    ptr_PrimVariant()
    {
        return reinterpret_cast<PrimVariant*>((&((mValue).VPrimVariant)));
    }
    const PrimVariant* const
    constptr_PrimVariant() const
    {
        return reinterpret_cast<const PrimVariant* const>((&((mValue).VPrimVariant)));
    }
    CompVariant*&
    ptr_CompVariant()
    {
        return (mValue).VCompVariant;
    }
    const CompVariant* const
    constptr_CompVariant() const
    {
        return (mValue).VCompVariant;
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    Variant() :
        mType(T__None)
    {
    }

    Variant(const PrimVariant& aOther);

    Variant(const CompVariant& aOther);

    Variant(const Variant& aOther);

    ~Variant();

    Type
    type() const
    {
        return mType;
    }

    Variant&
    operator=(const PrimVariant& aRhs);

    Variant&
    operator=(const CompVariant& aRhs);

    Variant&
    operator=(const Variant& aRhs);

    bool
    operator==(const PrimVariant& aRhs) const;

    bool
    operator==(const CompVariant& aRhs) const;

    bool
    operator==(const Variant& aRhs) const;

    PrimVariant&
    get_PrimVariant()
    {
        AssertSanity(TPrimVariant);
        return (*(ptr_PrimVariant()));
    }
    const PrimVariant&
    get_PrimVariant() const
    {
        AssertSanity(TPrimVariant);
        return (*(constptr_PrimVariant()));
    }
    operator PrimVariant&()
    {
        return get_PrimVariant();
    }
    operator const PrimVariant&() const
    {
        return get_PrimVariant();
    }

    CompVariant&
    get_CompVariant()
    {
        AssertSanity(TCompVariant);
        return (*(ptr_CompVariant()));
    }
    const CompVariant&
    get_CompVariant() const
    {
        AssertSanity(TCompVariant);
        return (*(constptr_CompVariant()));
    }
    operator CompVariant&()
    {
        return get_CompVariant();
    }
    operator const CompVariant&() const
    {
        return get_CompVariant();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace jetpack
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PJetpackChild and PJetpackParent
//
namespace mozilla {
namespace jetpack {
namespace PJetpack {

enum State {
    __Dead,
    __Null,
    __Error,
    __Start = __Null
};

enum MessageType {
    PJetpackStart = PJetpackMsgStart << 16,
    PJetpackPreStart = (PJetpackMsgStart << 16) - 1,
    Msg_SendMessage__ID,
    Msg_PHandleConstructor__ID,
    Reply_PHandleConstructor__ID,
    Msg_EvalScript__ID,
    Msg_CallMessage__ID,
    Reply_CallMessage__ID,
    PJetpackEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_SendMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::jetpack::KeyValue KeyValue;
    typedef mozilla::jetpack::PrimVariant PrimVariant;
    typedef mozilla::jetpack::CompVariant CompVariant;
    typedef mozilla::jetpack::Variant Variant;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::void_t void_t;
    typedef mozilla::null_t null_t;

public:
    enum {
        ID = Msg_SendMessage__ID
    };
    Msg_SendMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PJetpack::Msg_SendMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SendMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_PHandleConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::jetpack::KeyValue KeyValue;
    typedef mozilla::jetpack::PrimVariant PrimVariant;
    typedef mozilla::jetpack::CompVariant CompVariant;
    typedef mozilla::jetpack::Variant Variant;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::void_t void_t;
    typedef mozilla::null_t null_t;

public:
    enum {
        ID = Msg_PHandleConstructor__ID
    };
    Msg_PHandleConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PJetpack::Msg_PHandleConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PHandleConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_PHandleConstructor :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::jetpack::KeyValue KeyValue;
    typedef mozilla::jetpack::PrimVariant PrimVariant;
    typedef mozilla::jetpack::CompVariant CompVariant;
    typedef mozilla::jetpack::Variant Variant;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::void_t void_t;
    typedef mozilla::null_t null_t;

public:
    enum {
        ID = Reply_PHandleConstructor__ID
    };
    Reply_PHandleConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PJetpack::Reply_PHandleConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PHandleConstructor(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_EvalScript :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::jetpack::KeyValue KeyValue;
    typedef mozilla::jetpack::PrimVariant PrimVariant;
    typedef mozilla::jetpack::CompVariant CompVariant;
    typedef mozilla::jetpack::Variant Variant;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::void_t void_t;
    typedef mozilla::null_t null_t;

public:
    enum {
        ID = Msg_EvalScript__ID
    };
    Msg_EvalScript() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PJetpack::Msg_EvalScript")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_EvalScript(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Msg_CallMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::jetpack::KeyValue KeyValue;
    typedef mozilla::jetpack::PrimVariant PrimVariant;
    typedef mozilla::jetpack::CompVariant CompVariant;
    typedef mozilla::jetpack::Variant Variant;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::void_t void_t;
    typedef mozilla::null_t null_t;

public:
    enum {
        ID = Msg_CallMessage__ID
    };
    Msg_CallMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PJetpack::Msg_CallMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_CallMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};

class Reply_CallMessage :
    public IPC::Message
{
private:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::jetpack::KeyValue KeyValue;
    typedef mozilla::jetpack::PrimVariant PrimVariant;
    typedef mozilla::jetpack::CompVariant CompVariant;
    typedef mozilla::jetpack::Variant Variant;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::void_t void_t;
    typedef mozilla::null_t null_t;

public:
    enum {
        ID = Reply_CallMessage__ID
    };
    Reply_CallMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, PRIORITY_NORMAL, "PJetpack::Reply_CallMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            FILE* __outf) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "]", PR_Now());
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_CallMessage(");

        (__logmsg).append("[TODO])\n");
        fputs((__logmsg).c_str(), __outf);
    }
};



} // namespace PJetpack
} // namespace jetpack
} // namespace mozilla

#endif // ifndef PJetpack_h
