//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PRenderFrameParent_h
#define PRenderFrameParent_h

#include "mozilla/layout/PRenderFrame.h"
namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace layers {
class PLayersParent;
} // namespace layers
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace layers {
class PLayersParent;
} // namespace layers
} // namespace mozilla


namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace layout {


class /*NS_ABSTRACT_CLASS*/ PRenderFrameParent :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::layers::PLayersParent;

    friend class mozilla::dom::PBrowserParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::LayersBackend LayersBackend;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::layers::PLayersParent PLayersParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PRenderFrame::State State;

    virtual bool
    RecvPLayersConstructor(
            PLayersParent* actor,
            LayersBackend* backend);
    virtual bool
    Recv__delete__();
    virtual PLayersParent*
    AllocPLayers(LayersBackend* backend) = 0;
    virtual bool
    DeallocPLayers(PLayersParent* actor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PRenderFrameParent();

    virtual ~PRenderFrameParent();

    PBrowserParent*
    Manager();

    void
    ManagedPLayersParent(InfallibleTArray<PLayersParent*>& aArr) const;
    const InfallibleTArray<PLayersParent*>&
    ManagedPLayersParent() const;

    PRenderFrame::State
    state();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PRenderFrameParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PRenderFrameParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PLayersParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PLayersParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
    // Sorted by pointer value
    InfallibleTArray<PLayersParent*> mManagedPLayersParent;
};


} // namespace layout
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layout {
class RenderFrameParent :
    public PRenderFrameParent
{
    virtual PLayersParent*
    AllocPLayers(LayersBackend* backend);

    virtual bool
    DeallocPLayers(PLayersParent* actor);

    RenderFrameParent();
    virtual ~RenderFrameParent();
};
} // namespace layout
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layout {
PLayersParent*
RenderFrameParent::AllocPLayers(LayersBackend* backend)
{
    return 0;
}

bool
RenderFrameParent::DeallocPLayers(PLayersParent* actor)
{
    return false;
}

RenderFrameParent::RenderFrameParent()
{
    MOZ_COUNT_CTOR(RenderFrameParent);
}

RenderFrameParent::~RenderFrameParent()
{
    MOZ_COUNT_DTOR(RenderFrameParent);
}

} // namespace layout
} // namespace mozilla
#endif // if 0

#endif // ifndef PRenderFrameParent_h
