//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFTPChannelChild_h
#define PFTPChannelChild_h

#include "mozilla/net/PFTPChannel.h"
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PFTPChannelChild :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef IPC::URI URI;
    typedef IPC::InputStream InputStream;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PFTPChannel::State State;

    virtual bool
    RecvOnStartRequest(
            const PRInt32& aContentLength,
            const nsCString& aContentType,
            const PRTime& aLastModified,
            const nsCString& aEntityID,
            const URI& aURI) = 0;
    virtual bool
    RecvOnDataAvailable(
            const nsCString& data,
            const PRUint32& offset,
            const PRUint32& count) = 0;
    virtual bool
    RecvOnStopRequest(const nsresult& statusCode) = 0;
    virtual bool
    RecvCancelEarly(const nsresult& statusCode) = 0;
    virtual bool
    RecvDeleteSelf() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PFTPChannelChild();

    virtual ~PFTPChannelChild();

    PNeckoChild*
    Manager();

    PFTPChannel::State
    state();

    static bool
    Send__delete__(PFTPChannelChild* actor);

    bool
    SendAsyncOpen(
            const URI& uri,
            const PRUint64& startPos,
            const nsCString& entityID,
            const InputStream& uploadStream);

    bool
    SendConnectChannel(const PRUint32& channelId);

    bool
    SendCancel(const nsresult& status);

    bool
    SendSuspend();

    bool
    SendResume();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PFTPChannelChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PFTPChannelChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class FTPChannelChild :
    public PFTPChannelChild
{
    virtual bool
    RecvOnStartRequest(
            const PRInt32& aContentLength,
            const nsCString& aContentType,
            const PRTime& aLastModified,
            const nsCString& aEntityID,
            const URI& aURI);

    virtual bool
    RecvOnDataAvailable(
            const nsCString& data,
            const PRUint32& offset,
            const PRUint32& count);

    virtual bool
    RecvOnStopRequest(const nsresult& statusCode);

    virtual bool
    RecvCancelEarly(const nsresult& statusCode);

    virtual bool
    RecvDeleteSelf();

    FTPChannelChild();
    virtual ~FTPChannelChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
FTPChannelChild::RecvOnStartRequest(
        const PRInt32& aContentLength,
        const nsCString& aContentType,
        const PRTime& aLastModified,
        const nsCString& aEntityID,
        const URI& aURI)
{
    return false;
}

bool
FTPChannelChild::RecvOnDataAvailable(
        const nsCString& data,
        const PRUint32& offset,
        const PRUint32& count)
{
    return false;
}

bool
FTPChannelChild::RecvOnStopRequest(const nsresult& statusCode)
{
    return false;
}

bool
FTPChannelChild::RecvCancelEarly(const nsresult& statusCode)
{
    return false;
}

bool
FTPChannelChild::RecvDeleteSelf()
{
    return false;
}

FTPChannelChild::FTPChannelChild()
{
    MOZ_COUNT_CTOR(FTPChannelChild);
}

FTPChannelChild::~FTPChannelChild()
{
    MOZ_COUNT_DTOR(FTPChannelChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PFTPChannelChild_h
