//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBrowserStreamChild_h
#define PBrowserStreamChild_h

#include "mozilla/plugins/PBrowserStream.h"
namespace mozilla {
namespace plugins {
class PPluginInstanceChild;
} // namespace plugins
} // namespace mozilla

#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/RPCChannel.h"


namespace mozilla {
namespace plugins {
class PPluginInstanceChild;
} // namespace plugins
} // namespace mozilla

namespace mozilla {
namespace plugins {


class /*NS_ABSTRACT_CLASS*/ PBrowserStreamChild :
    protected mozilla::ipc::RPCChannel::RPCListener,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>
{
    friend class mozilla::plugins::PPluginInstanceChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::plugins::Buffer Buffer;
    typedef mozilla::plugins::IPCByteRanges IPCByteRanges;
    typedef mozilla::plugins::PPluginInstanceChild PPluginInstanceChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PBrowserStream::State State;

    virtual bool
    RecvWrite(
            const int32_t& offset,
            const Buffer& data,
            const uint32_t& newlength) = 0;
    virtual bool
    RecvNPP_StreamAsFile(const nsCString& fname) = 0;
    virtual bool
    RecvNPP_DestroyStream(const NPReason& reason) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason why);

public:
    typedef IPC::Message Message;
    typedef mozilla::ipc::RPCChannel Channel;
    typedef mozilla::ipc::RPCChannel::RPCListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::AsyncChannel AsyncChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    PBrowserStreamChild();

    virtual ~PBrowserStreamChild();

    PPluginInstanceChild*
    Manager();

    PBrowserStream::State
    state();

    bool
    CallNPN_RequestRead(
            const IPCByteRanges& ranges,
            NPError* result);

    bool
    SendNPN_DestroyStream(const NPReason& reason);

    bool
    SendStreamDestroyed();

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result code);

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32 pid);

    virtual int32
    Register(ChannelListener* aRouted);
    virtual int32
    RegisterID(
            ChannelListener* aRouted,
            int32 aId);
    virtual ChannelListener*
    Lookup(int32 aId);
    virtual void
    Unregister(int32 aId);
    virtual void
    RemoveManagee(
            int32 aProtocolId,
            ChannelListener* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType type,
            bool unsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& aShmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual AsyncChannel*
    GetIPCChannel();

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    virtual void
    FatalError(const char* const msg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PBrowserStreamChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PBrowserStreamChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    int32 mId;
    mozilla::ipc::IProtocolManager<mozilla::ipc::RPCChannel::RPCListener>* mManager;
    State mState;
};


} // namespace plugins
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace plugins {
class BrowserStreamChild :
    public PBrowserStreamChild
{
    virtual bool
    RecvWrite(
            const int32_t& offset,
            const Buffer& data,
            const uint32_t& newlength);

    virtual bool
    RecvNPP_StreamAsFile(const nsCString& fname);

    virtual bool
    RecvNPP_DestroyStream(const NPReason& reason);

    BrowserStreamChild();
    virtual ~BrowserStreamChild();
};
} // namespace plugins
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace plugins {
bool
BrowserStreamChild::RecvWrite(
        const int32_t& offset,
        const Buffer& data,
        const uint32_t& newlength)
{
    return false;
}

bool
BrowserStreamChild::RecvNPP_StreamAsFile(const nsCString& fname)
{
    return false;
}

bool
BrowserStreamChild::RecvNPP_DestroyStream(const NPReason& reason)
{
    return false;
}

BrowserStreamChild::BrowserStreamChild()
{
    MOZ_COUNT_CTOR(BrowserStreamChild);
}

BrowserStreamChild::~BrowserStreamChild()
{
    MOZ_COUNT_DTOR(BrowserStreamChild);
}

} // namespace plugins
} // namespace mozilla
#endif // if 0

#endif // ifndef PBrowserStreamChild_h
