/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "nsHTMLSelectElement.h"
#include "nsIContent.h"
#include "nsIHTMLCollection.h"
#include "nsINodeList.h"
#include "nsISupports.h"

namespace mozilla {
namespace dom {
namespace binding {

// Property name ids

static jsid s_add_id = JSID_VOID;
static jsid s_item_id = JSID_VOID;
static jsid s_namedItem_id = JSID_VOID;
static jsid s_remove_id = JSID_VOID;
static jsid s_selectedIndex_id = JSID_VOID;
static jsid s_setOption_id = JSID_VOID;

bool
DefinePropertyStaticJSVals(JSContext *cx)
{
    return SET_JSID_TO_STRING(cx, add) &&
           SET_JSID_TO_STRING(cx, item) &&
           SET_JSID_TO_STRING(cx, namedItem) &&
           SET_JSID_TO_STRING(cx, remove) &&
           SET_JSID_TO_STRING(cx, selectedIndex) &&
           SET_JSID_TO_STRING(cx, setOption);
}

// Typedefs

// HTMLCollection

typedef ListClass<nsIHTMLCollection, Ops<Getter<nsIContent *> >, Ops<Getter<nsISupportsResult> > > HTMLCollectionClass;
typedef ListBase<HTMLCollectionClass> HTMLCollectionWrapper;


// HTMLOptionsCollection

typedef DerivedListClass<nsHTMLOptionCollection, HTMLCollectionWrapper, Ops<Getter<nsIContent *>, Setter<nsIDOMHTMLOptionElement *> >, Ops<Getter<nsISupportsResult> > > HTMLOptionsCollectionClass;
typedef ListBase<HTMLOptionsCollectionClass> HTMLOptionsCollectionWrapper;


// NodeList

typedef ListClass<nsINodeList, Ops<Getter<nsIContent *> > > NodeListClass;
typedef ListBase<NodeListClass> NodeListWrapper;


// Implementation

// HTMLCollection

template<>
js::Class HTMLCollectionWrapper::sInterfaceClass = {
    "HTMLCollection",
    0,
    JS_PropertyStub,        /* addProperty */
    JS_PropertyStub,        /* delProperty */
    JS_PropertyStub,        /* getProperty */
    JS_StrictPropertyStub,  /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    NULL,                   /* finalize */
    NULL,                   /* reserved0 */
    NULL,                   /* checkAccess */
    NULL,                   /* call */
    NULL,                   /* construct */
    NULL,                   /* xdrObject */
    interface_hasInstance
};

template<>
bool
HTMLCollectionWrapper::objIsList(JSObject *obj)
{
    if (!js::IsProxy(obj))
        return false;
    js::ProxyHandler *handler = js::GetProxyHandler(obj);
    return proxyHandlerIsList(handler) ||
           HTMLOptionsCollectionWrapper::proxyHandlerIsList(handler);
}

template<>
nsIHTMLCollection*
HTMLCollectionWrapper::getNative(JSObject *obj)
{
    js::ProxyHandler *handler = js::GetProxyHandler(obj);
    if (proxyHandlerIsList(handler))
        return static_cast<nsIHTMLCollection*>(js::GetProxyPrivate(obj).toPrivate());
    if (HTMLOptionsCollectionWrapper::proxyHandlerIsList(handler))
        return HTMLOptionsCollectionWrapper::getNative(obj);

    NS_RUNTIMEABORT("Unknown list type!");
    return NULL;
}

template<>
bool
HTMLCollectionWrapper::getItemAt(nsIHTMLCollection *list, uint32 index, nsIContent * &item)
{
    item = list->GetNodeAt(index);
    return !!item;
}

template<>
bool
HTMLCollectionWrapper::getNamedItem(nsIHTMLCollection *list, const nsAString& index, nsISupportsResult &item)
{
    item.mResult = list->GetNamedItem(index, &item.mCache);
    return !!item.mResult;
}

static JSBool
HTMLCollection_Item(JSContext *cx, uintN argc, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    JSObject *obj = JS_THIS_OBJECT(cx, vp);
    if (!obj)
        return JS_FALSE;
    JSObject *callee = JSVAL_TO_OBJECT(JS_CALLEE(cx, vp));
    if (!HTMLCollectionWrapper::instanceIsListObject(cx, obj, callee))
        return false;
    if (argc < 1)
        return xpc_qsThrow(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
    jsval *argv = JS_ARGV(cx, vp);
    uint32 arg0;
    if (!JS_ValueToECMAUint32(cx, argv[0], &arg0))
        return JS_FALSE;
    nsIContent *result;
    result = HTMLCollectionWrapper::getListObject(obj)->GetNodeAt(arg0);
    if (!result) {
      *vp = JSVAL_NULL;
      return JS_TRUE;
    }
    return Wrap(cx, obj, result, vp);
}

static JSBool
HTMLCollection_NamedItem(JSContext *cx, uintN argc, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    JSObject *obj = JS_THIS_OBJECT(cx, vp);
    if (!obj)
        return JS_FALSE;
    JSObject *callee = JSVAL_TO_OBJECT(JS_CALLEE(cx, vp));
    if (!HTMLCollectionWrapper::instanceIsListObject(cx, obj, callee))
        return false;
    if (argc < 1)
        return xpc_qsThrow(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
    jsval *argv = JS_ARGV(cx, vp);
    xpc_qsDOMString arg0(cx, argv[0], &argv[0], xpc_qsDOMString::eDefaultNullBehavior, xpc_qsDOMString::eDefaultUndefinedBehavior);
    if (!arg0.IsValid())
        return JS_FALSE;
    nsWrapperCache *cache;
    nsISupports *result;
    result = HTMLCollectionWrapper::getListObject(obj)->GetNamedItem(arg0, &cache);
    if (!result) {
      *vp = JSVAL_NULL;
      return JS_TRUE;
    }
    return Wrap(cx, obj, result, cache, vp);
}

template<>
HTMLCollectionWrapper::Properties HTMLCollectionWrapper::sProtoProperties[] = {
    { s_length_id, length_getter, NULL }
};

template<>
HTMLCollectionWrapper::Methods HTMLCollectionWrapper::sProtoMethods[] = {
    { s_item_id, HTMLCollection_Item, 1 },
    { s_namedItem_id, HTMLCollection_NamedItem, 1 }
};

template class ListBase<HTMLCollectionClass>;

JSObject*
HTMLCollection::create(JSContext *cx, XPCWrappedNativeScope *scope, nsIHTMLCollection *list, nsWrapperCache *cache, bool *triedToWrap)
{
    return HTMLCollectionWrapper::create(cx, scope, list, cache, triedToWrap);
}

bool
HTMLCollection::objIsWrapper(JSObject *obj)
{
    return HTMLCollectionWrapper::objIsList(obj);
}

nsIHTMLCollection*
HTMLCollection::getNative(JSObject *obj)
{
    return HTMLCollectionWrapper::getListObject(obj);
}

// HTMLOptionsCollection

template<>
js::Class HTMLOptionsCollectionWrapper::sInterfaceClass = {
    "HTMLOptionsCollection",
    0,
    JS_PropertyStub,        /* addProperty */
    JS_PropertyStub,        /* delProperty */
    JS_PropertyStub,        /* getProperty */
    JS_StrictPropertyStub,  /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    NULL,                   /* finalize */
    NULL,                   /* reserved0 */
    NULL,                   /* checkAccess */
    NULL,                   /* call */
    NULL,                   /* construct */
    NULL,                   /* xdrObject */
    interface_hasInstance
};

template<>
bool
HTMLOptionsCollectionWrapper::getItemAt(nsHTMLOptionCollection *list, uint32 index, nsIContent * &item)
{
    item = list->GetNodeAt(index);
    return !!item;
}

template<>
bool
HTMLOptionsCollectionWrapper::setItemAt(JSContext *cx, nsHTMLOptionCollection *list, uint32 index, nsIDOMHTMLOptionElement * item)
{
    nsresult rv = list->SetOption(index, item);
    return NS_SUCCEEDED(rv) ? true : Throw(cx, rv);
}

template<>
bool
HTMLOptionsCollectionWrapper::getNamedItem(nsHTMLOptionCollection *list, const nsAString& index, nsISupportsResult &item)
{
    item.mResult = list->GetNamedItem(index, &item.mCache);
    return !!item.mResult;
}

static JSBool
HTMLOptionsCollection_Add(JSContext *cx, uintN argc, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    JSObject *obj = JS_THIS_OBJECT(cx, vp);
    if (!obj)
        return JS_FALSE;
    XPCCallContext ccx(JS_CALLER, cx, obj, JSVAL_TO_OBJECT(JS_CALLEE(cx, vp)));
    JSObject *callee = JSVAL_TO_OBJECT(JS_CALLEE(cx, vp));
    if (!HTMLOptionsCollectionWrapper::instanceIsListObject(cx, obj, callee))
        return false;
    if (argc < 1)
        return xpc_qsThrow(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
    jsval *argv = JS_ARGV(cx, vp);
    nsresult rv;
    nsIDOMHTMLOptionElement *arg0;
    xpc_qsSelfRef arg0ref;
    rv = xpc_qsUnwrapArg<nsIDOMHTMLOptionElement>(cx, argv[0], &arg0, &arg0ref.ptr, &argv[0]);
    if (NS_FAILED(rv)) {
        xpc_qsThrowBadArgWithCcx(ccx, rv, 0);
        return JS_FALSE;
    }
    nsCOMPtr<nsIVariant> arg1(already_AddRefed<nsIVariant>(XPCVariant::newVariant(ccx, (1 < argc ? argv[1] : JSVAL_NULL))));
    if (!arg1) {
        xpc_qsThrowBadArgWithCcx(ccx, NS_ERROR_XPC_BAD_CONVERT_JS, 1);
        return JS_FALSE;
    }
    rv = HTMLOptionsCollectionWrapper::getListObject(obj)->Add(arg0, arg1);
    if (NS_FAILED(rv)) {
        xpc_qsThrowMethodFailedWithDetails(cx, rv, "HTMLOptionsCollection", "add");
        return JS_FALSE;
    }
    *vp = JSVAL_VOID;
    return JS_TRUE;
}

static JSBool
HTMLOptionsCollection_Item(JSContext *cx, uintN argc, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    JSObject *obj = JS_THIS_OBJECT(cx, vp);
    if (!obj)
        return JS_FALSE;
    JSObject *callee = JSVAL_TO_OBJECT(JS_CALLEE(cx, vp));
    if (!HTMLOptionsCollectionWrapper::instanceIsListObject(cx, obj, callee))
        return false;
    if (argc < 1)
        return xpc_qsThrow(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
    jsval *argv = JS_ARGV(cx, vp);
    uint32 arg0;
    if (!JS_ValueToECMAUint32(cx, argv[0], &arg0))
        return JS_FALSE;
    nsresult rv;
    nsCOMPtr<nsIDOMNode> result;
    rv = HTMLOptionsCollectionWrapper::getListObject(obj)->Item(arg0, getter_AddRefs(result));
    if (NS_FAILED(rv)) {
        xpc_qsThrowMethodFailedWithDetails(cx, rv, "HTMLOptionsCollection", "item");
        return JS_FALSE;
    }
    if (!result) {
      *vp = JSVAL_NULL;
      return JS_TRUE;
    }
    return Wrap(cx, obj, result, vp);
}

static JSBool
HTMLOptionsCollection_SetLength(JSContext *cx, JSObject *obj, jsid id, JSBool strict, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    if (!HTMLOptionsCollectionWrapper::instanceIsListObject(cx, obj, NULL))
        return false;
    uint32 arg0;
    if (!JS_ValueToECMAUint32(cx, *vp, &arg0))
        return JS_FALSE;
    nsresult rv;
    rv = HTMLOptionsCollectionWrapper::getListObject(obj)->SetLength(arg0);
    if (NS_FAILED(rv)) {
        xpc_qsThrowMethodFailedWithDetails(cx, rv, "HTMLOptionsCollection", "length");
        return JS_FALSE;
    }
    return JS_TRUE;
}

static JSBool
HTMLOptionsCollection_NamedItem(JSContext *cx, uintN argc, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    JSObject *obj = JS_THIS_OBJECT(cx, vp);
    if (!obj)
        return JS_FALSE;
    JSObject *callee = JSVAL_TO_OBJECT(JS_CALLEE(cx, vp));
    if (!HTMLOptionsCollectionWrapper::instanceIsListObject(cx, obj, callee))
        return false;
    if (argc < 1)
        return xpc_qsThrow(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
    jsval *argv = JS_ARGV(cx, vp);
    xpc_qsDOMString arg0(cx, argv[0], &argv[0], xpc_qsDOMString::eDefaultNullBehavior, xpc_qsDOMString::eDefaultUndefinedBehavior);
    if (!arg0.IsValid())
        return JS_FALSE;
    nsWrapperCache *cache;
    nsISupports *result;
    result = HTMLOptionsCollectionWrapper::getListObject(obj)->GetNamedItem(arg0, &cache);
    if (!result) {
      *vp = JSVAL_NULL;
      return JS_TRUE;
    }
    return Wrap(cx, obj, result, cache, vp);
}

static JSBool
HTMLOptionsCollection_Remove(JSContext *cx, uintN argc, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    JSObject *obj = JS_THIS_OBJECT(cx, vp);
    if (!obj)
        return JS_FALSE;
    JSObject *callee = JSVAL_TO_OBJECT(JS_CALLEE(cx, vp));
    if (!HTMLOptionsCollectionWrapper::instanceIsListObject(cx, obj, callee))
        return false;
    if (argc < 1)
        return xpc_qsThrow(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
    jsval *argv = JS_ARGV(cx, vp);
    int32 arg0;
    if (!JS_ValueToECMAInt32(cx, argv[0], &arg0))
        return JS_FALSE;
    nsresult rv;
    rv = HTMLOptionsCollectionWrapper::getListObject(obj)->Remove(arg0);
    if (NS_FAILED(rv)) {
        xpc_qsThrowMethodFailedWithDetails(cx, rv, "HTMLOptionsCollection", "remove");
        return JS_FALSE;
    }
    *vp = JSVAL_VOID;
    return JS_TRUE;
}

static JSBool
HTMLOptionsCollection_GetSelectedIndex(JSContext *cx, JSObject *obj, jsid id, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    if (!HTMLOptionsCollectionWrapper::instanceIsListObject(cx, obj, NULL))
        return false;
    nsresult rv;
    PRInt32 result;
    rv = HTMLOptionsCollectionWrapper::getListObject(obj)->GetSelectedIndex(&result);
    if (NS_FAILED(rv)) {
        xpc_qsThrowMethodFailedWithDetails(cx, rv, "HTMLOptionsCollection", "selectedIndex");
        return JS_FALSE;
    }
    return xpc_qsInt32ToJsval(cx, result, vp);
}

static JSBool
HTMLOptionsCollection_SetSelectedIndex(JSContext *cx, JSObject *obj, jsid id, JSBool strict, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    if (!HTMLOptionsCollectionWrapper::instanceIsListObject(cx, obj, NULL))
        return false;
    int32 arg0;
    if (!JS_ValueToECMAInt32(cx, *vp, &arg0))
        return JS_FALSE;
    nsresult rv;
    rv = HTMLOptionsCollectionWrapper::getListObject(obj)->SetSelectedIndex(arg0);
    if (NS_FAILED(rv)) {
        xpc_qsThrowMethodFailedWithDetails(cx, rv, "HTMLOptionsCollection", "selectedIndex");
        return JS_FALSE;
    }
    return JS_TRUE;
}

template<>
HTMLOptionsCollectionWrapper::Properties HTMLOptionsCollectionWrapper::sProtoProperties[] = {
    { s_length_id, length_getter, HTMLOptionsCollection_SetLength },
    { s_selectedIndex_id, HTMLOptionsCollection_GetSelectedIndex, HTMLOptionsCollection_SetSelectedIndex }
};

template<>
HTMLOptionsCollectionWrapper::Methods HTMLOptionsCollectionWrapper::sProtoMethods[] = {
    { s_add_id, HTMLOptionsCollection_Add, 2 },
    { s_item_id, HTMLOptionsCollection_Item, 1 },
    { s_namedItem_id, HTMLOptionsCollection_NamedItem, 1 },
    { s_remove_id, HTMLOptionsCollection_Remove, 1 }
};

template class ListBase<HTMLOptionsCollectionClass>;

JSObject*
HTMLOptionsCollection::create(JSContext *cx, XPCWrappedNativeScope *scope, nsHTMLOptionCollection *list, nsWrapperCache *cache, bool *triedToWrap)
{
    return HTMLOptionsCollectionWrapper::create(cx, scope, list, cache, triedToWrap);
}

bool
HTMLOptionsCollection::objIsWrapper(JSObject *obj)
{
    return HTMLOptionsCollectionWrapper::objIsList(obj);
}

nsHTMLOptionCollection*
HTMLOptionsCollection::getNative(JSObject *obj)
{
    return HTMLOptionsCollectionWrapper::getListObject(obj);
}

// NodeList

template<>
js::Class NodeListWrapper::sInterfaceClass = {
    "NodeList",
    0,
    JS_PropertyStub,        /* addProperty */
    JS_PropertyStub,        /* delProperty */
    JS_PropertyStub,        /* getProperty */
    JS_StrictPropertyStub,  /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    NULL,                   /* finalize */
    NULL,                   /* reserved0 */
    NULL,                   /* checkAccess */
    NULL,                   /* call */
    NULL,                   /* construct */
    NULL,                   /* xdrObject */
    interface_hasInstance
};

template<>
bool
NodeListWrapper::getItemAt(nsINodeList *list, uint32 index, nsIContent * &item)
{
    item = list->GetNodeAt(index);
    return !!item;
}

static JSBool
NodeList_Item(JSContext *cx, uintN argc, jsval *vp)
{
    XPC_QS_ASSERT_CONTEXT_OK(cx);
    JSObject *obj = JS_THIS_OBJECT(cx, vp);
    if (!obj)
        return JS_FALSE;
    JSObject *callee = JSVAL_TO_OBJECT(JS_CALLEE(cx, vp));
    if (!NodeListWrapper::instanceIsListObject(cx, obj, callee))
        return false;
    if (argc < 1)
        return xpc_qsThrow(cx, NS_ERROR_XPC_NOT_ENOUGH_ARGS);
    jsval *argv = JS_ARGV(cx, vp);
    uint32 arg0;
    if (!JS_ValueToECMAUint32(cx, argv[0], &arg0))
        return JS_FALSE;
    nsIContent *result;
    result = NodeListWrapper::getListObject(obj)->GetNodeAt(arg0);
    if (!result) {
      *vp = JSVAL_NULL;
      return JS_TRUE;
    }
    return Wrap(cx, obj, result, vp);
}

template<>
NodeListWrapper::Properties NodeListWrapper::sProtoProperties[] = {
    { s_length_id, length_getter, NULL }
};

template<>
NodeListWrapper::Methods NodeListWrapper::sProtoMethods[] = {
    { s_item_id, NodeList_Item, 1 }
};

template class ListBase<NodeListClass>;

JSObject*
NodeList::create(JSContext *cx, XPCWrappedNativeScope *scope, nsINodeList *list, nsWrapperCache *cache, bool *triedToWrap)
{
    return NodeListWrapper::create(cx, scope, list, cache, triedToWrap);
}

bool
NodeList::objIsWrapper(JSObject *obj)
{
    return NodeListWrapper::objIsList(obj);
}

nsINodeList*
NodeList::getNative(JSObject *obj)
{
    return NodeListWrapper::getListObject(obj);
}

// Register prototypes

void
Register(nsDOMClassInfoData *aData)
{
#define REGISTER_PROTO(_dom_class) \
    aData[eDOMClassInfo_##_dom_class##_id].mDefineDOMInterface = _dom_class##Wrapper::getPrototype

    REGISTER_PROTO(NodeList);
    REGISTER_PROTO(HTMLCollection);
    REGISTER_PROTO(HTMLOptionsCollection);

#undef REGISTER_PROTO
}

}
}
}
